/*****************************************************************

  GLmame include file

  Copyright 1998 by Mike Oliphant - oliphant@ling.ed.ac.uk

    http://www.ling.ed.ac.uk/~oliphant/glmame

  This code may be used and distributed under the terms of the
  Mame license

  Patched for Win32 OpenGL Version
  29/April/1999 Sven Goethel, http://www.jausoft.com

*****************************************************************/

#include <GL/gl.h>
#include <GL/glu.h>

#ifndef WIN32
#include "xmame.h"
#endif

/* Camera panning stuff */

typedef enum {pan_goto,pan_moveto,pan_repeat,pan_end,pan_nocab} PanType;

struct CameraPan {
  PanType type;      /* Type of pan */
  GLfloat lx,ly,lz;  /* Location of camera */
  GLfloat px,py,pz;  /* Vector to point camera along */
  GLfloat nx,ny,nz;  /* Normal to camera direction */
  int frames;        /* Number of frames for transition */
};

#define OSD_OK			(0)
#define OSD_NOT_OK		(1)

/** The code actualy ONLY works if glColorTableEXT works and exists !!
#ifdef GL_EXT_paletted_texture
	#undef GL_EXT_paletted_texture //just for testing purposes ... 
#endif
  **/

#ifdef WIN32
#ifdef GL_EXT_paletted_texture
	extern PFNGLCOLORTABLEEXTPROC glColorTableEXT;
#endif
#endif

#ifdef GL_EXT_paletted_texture
	extern GLubyte *ctable;			// for OpenGL
#endif

extern GLushort *rcolmap, *gcolmap, *bcolmap, *acolmap;

extern int ctable_size; /* the true color table size */
extern GLenum gl_bitmap_format;
extern unsigned char gl_alpha_value; /* customize it :-) */
extern float gamma_correction;
extern GLsizei text_width;
extern GLsizei text_height;
extern int force_text_width_height;

extern int screendirty;

extern int antialias;
extern int cabview;
extern char cabname[]; /* 512 bytes reserved ... */
extern int cabspecified;

extern int bilinear; 
extern int alphablending; 
extern GLint bitmap_lod; /* level of display-detail of the bitmap-texture */

extern int gl_is_initialized;

#ifdef WIN32
extern int useBMPSnap;
#endif
extern int usePNGSnap;
extern int useJPGSnap;
extern int usePPMSnap;
extern int jpgQuality;


int glHasEXT(void);
void glSetUseEXT(int val);
int glGetUseEXT(void);

int
#ifdef WIN32
	gl_allocate_colors
#else
	osd_allocate_colors
#endif
	(unsigned int _totalcolors, const unsigned char *palette, unsigned short *pens, int modifiable);

void
#ifdef WIN32
	gl_modify_pen
#else
	osd_modify_pen
#endif
	(int pen, unsigned char red,unsigned char green, unsigned char blue) ;

void
#ifdef WIN32
	gl_get_pen
#else
	osd_get_pen
#endif
	(int pen, unsigned char* pRed, unsigned char* pGreen, unsigned char* pBlue);

int gl_GetBlackPen(void);

void 
#ifdef WIN32
	gl_set_gamma
#else
	osd_set_gamma
#endif
	(float _gamma);

float
#ifdef WIN32
	gl_get_gamma
#else
	osd_get_gamma
#endif
	(void);

/* for compatibility issues ... uses alpha */
void 
#ifdef WIN32
	gl_set_brightness
#else
	osd_set_brightness
#endif
	(int _brightness);

int
#ifdef WIN32
	gl_get_brightness
#else
	osd_get_brightness
#endif
	(void);


void gl_set_alpha (unsigned char _alpha);

unsigned char gl_get_alpha (void);


void 
#ifdef WIN32
	gl_mark_dirty
#else
	osd_mark_dirty
#endif
    (int x1, int y1, int x2, int y2, int ui);

void
#ifdef WIN32
	gl_update_display
#else
	sysdep_update_display
#endif
	(void);

#ifdef WIN32
void bmp_save_snapshot (void);
#endif
void ppm_save_snapshot (void);
void png_save_snapshot (void);
void jpg_save_snapshot (void);
void gl_save_snapshot  (void);

void
#ifdef WIN32
	gl_refresh_screen
#else
	osd_refresh_screen
#endif
	(void);

void  gl_set_bilinear(int new_value);
void  gl_set_cabview(int new_value);
void  gl_set_antialias(int new_value);
void  gl_set_alphablending(int new_value);

void InitVScreen(void);
void CloseVScreen(void);





