/***************************************************************************

    M.A.M.E.32  -  Multiple Arcade Machine Emulator for Win32

    This file is part of the OpenGL Version of M.A.M.E., called GLMame32 !
	Copyright 1999 by Sven Goethel, http://www.jausoft.com
    
    This file is part of MAME32, and may only be used, modified and
    distributed under the terms of the MAME license, in "readme.txt".
    By continuing to use, modify or distribute this file you indicate
    that you have read the license and understand and accept it fully.

  Modified for GLMame32
  29/April/1999 Sven Goethel

 ***************************************************************************/

#ifndef __WGL_TOOL_H__
#define __WGL_TOOL_H__

#include <math.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <wingdi.h>

extern HDC glHDC;
extern HWND glWnd;
extern HGLRC glContext;

/* To select the pixel format -> We use a BRUTE FORCE ;-) */
/* We check from :
		color-planes		depth-planes		doublebuffer
		------------------------------------------------------
		   24					32					1
		   24					 0					1
		   
		   24					XX					1
		    8					XX					1
		
		   24					32					0
		   24					 0					0
			   
		   24					XX					0
		    8					XX					0
*/
HGLRC wglToolGetGLContext( HWND win, HDC hdc, 
						   int colorPlanes, int depthPlanes,
						   int verbose,
						   int * pDoublebuffer, 
						   int *pixFmtIdx);

RECT wglToolRetrieveWinSize(int *width, int *height);

#endif
